<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: Moco Examples</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('mocoexamples.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Moco Examples </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>Moco's examples are categorized as beginner, intermediate, and advanced.</p>
<p>Some examples are available from multiple interfaces. Use the links in the <b>Interfaces</b> column to view the code. In the <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> distribution, all examples are in the <code>Resources/Code/</code> folder.</p>
<dl class="section note"><dt>Note</dt><dd>The intent of all examples is to demonstrate Moco's interface. We do not validate the results of these examples. Users are responsible for validating their results before making any scientific claims.</dd></dl>
<h1><a class="anchor" id="Beginner"></a>
Beginner</h1>
<table class="markdownTable">
<tr class="markdownTableHead">
<th class="markdownTableHeadNone">name   </th><th class="markdownTableHeadNone">model/motion   </th><th class="markdownTableHeadNone">description   </th><th class="markdownTableHeadNone">interfaces    </th></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">SlidingMass   </td><td class="markdownTableBodyNone">point mass   </td><td class="markdownTableBodyNone">Moco's simplest example; <a class="el" href="classOpenSim_1_1MocoFinalTimeGoal.html" title="Endpoint cost for final time.">MocoFinalTimeGoal</a>   </td><td class="markdownTableBodyNone"><a class="el" href="exampleSlidingMass_8m-example.html">MATLAB</a>, <a class="el" href="exampleSlidingMass_8py-example.html">Python</a>, <a class="el" href="exampleSlidingMass_8cpp-example.html">C++</a>    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">SlidingMassAdvanced   </td><td class="markdownTableBodyNone">point mass   </td><td class="markdownTableBodyNone"><a class="el" href="classOpenSim_1_1MocoFinalTimeGoal.html" title="Endpoint cost for final time.">MocoFinalTimeGoal</a>, solver settings, customizing the initial guess   </td><td class="markdownTableBodyNone"><a class="el" href="exampleSlidingMassAdvanced_8cpp-example.html">C++</a>    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">Tracking   </td><td class="markdownTableBodyNone">double pendulum   </td><td class="markdownTableBodyNone">Using <a class="el" href="classOpenSim_1_1MocoStateTrackingGoal.html">MocoStateTrackingGoal</a>   </td><td class="markdownTableBodyNone"><a class="el" href="exampleTracking_8cpp-example.html">C++</a>    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">MarkerTracking   </td><td class="markdownTableBodyNone">double pendulum   </td><td class="markdownTableBodyNone">Using <a class="el" href="classOpenSim_1_1MocoMarkerTrackingGoal.html">MocoMarkerTrackingGoal</a>   </td><td class="markdownTableBodyNone"><a class="el" href="exampleMarkerTracking_8cpp-example.html">C++</a>    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">HangingMuscle   </td><td class="markdownTableBodyNone">point mass with muscle   </td><td class="markdownTableBodyNone"><a class="el" href="classOpenSim_1_1DeGrooteFregly2016Muscle.html" title="This muscle model was published in De Groote et al.">DeGrooteFregly2016Muscle</a>, <a class="el" href="classOpenSim_1_1Umberger2010MuscleMetabolicsProbe.html" title="Umberger2010MuscleMetabolicsProbe is a Probe ModelComponent for computing the net metabolic energy ra...">Umberger2010MuscleMetabolicsProbe</a>, <a class="el" href="classOpenSim_1_1AnalyzeTool.html" title="An abstract class for specifying the interface for an investigation.">AnalyzeTool</a>, <a class="el" href="classOpenSim_1_1MocoInitialActivationGoal.html" title="For all muscles with activation dynamics, the initial activation and initial excitation should be the...">MocoInitialActivationGoal</a>, <a class="el" href="classOpenSim_1_1MocoInitialVelocityEquilibriumDGFGoal.html" title="For DeGrooteFregly2016Muscle components with implicit tendon compliance dynamics, the initial tendon ...">MocoInitialVelocityEquilibriumDGFGoal</a>, plotting a TimeSeriesTable   </td><td class="markdownTableBodyNone"><a class="el" href="exampleHangingMuscle_8py-example.html">Python</a>, <a class="el" href="exampleHangingMuscle_8cpp-example.html">C++</a>    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">OptimizeMass   </td><td class="markdownTableBodyNone">point mass   </td><td class="markdownTableBodyNone">Parameter optimization with <a class="el" href="classOpenSim_1_1MocoMarkerFinalGoal.html" title="The squared distance between a single model point location and reference location in the final state.">MocoMarkerFinalGoal</a> and <a class="el" href="classOpenSim_1_1MocoParameter.html" title="A MocoParameter allows you to optimize property values in an OpenSim Model.">MocoParameter</a>   </td><td class="markdownTableBodyNone"><a class="el" href="exampleOptimizeMass_8m-example.html">MATLAB</a>, <a class="el" href="exampleOptimizeMass_8py-example.html">Python</a>    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">MinimizeJointReaction   </td><td class="markdownTableBodyNone">pendulum   </td><td class="markdownTableBodyNone"><a class="el" href="classOpenSim_1_1MocoJointReactionGoal.html" title="Minimize the sum of squares of specified reaction moment and force measures for a given joint,...">MocoJointReactionGoal</a>, <a class="el" href="classOpenSim_1_1MocoControlGoal.html" title="Minimize the sum of the absolute value of the controls raised to a given exponent,...">MocoControlGoal</a>, prescribeControlsToModel   </td><td class="markdownTableBodyNone"><a class="el" href="exampleMinimizeJointReaction_8m-example.html">MATLAB</a>    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">exampleKinematicConstraints   </td><td class="markdownTableBodyNone">point mass   </td><td class="markdownTableBodyNone">Point mass constrained to a parabola   </td><td class="markdownTableBodyNone"><a class="el" href="exampleKinematicConstraints_8py-example.html">Python</a>   </td></tr>
</table>
<h1><a class="anchor" id="Intermediate"></a>
Intermediate</h1>
<table class="markdownTable">
<tr class="markdownTableHead">
<th class="markdownTableHeadNone">name   </th><th class="markdownTableHeadNone">model/motion   </th><th class="markdownTableHeadNone">description   </th><th class="markdownTableHeadNone">interfaces    </th></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone"><a class="el" href="classOpenSim_1_1MocoTrack.html">MocoTrack</a>   </td><td class="markdownTableBodyNone">lower-limb   </td><td class="markdownTableBodyNone">Using the <a class="el" href="classOpenSim_1_1MocoTrack.html">MocoTrack</a> tool for walking with marker tracking and state tracking; generating a PDF report   </td><td class="markdownTableBodyNone"><a class="el" href="exampleMocoTrack_8m-example.html">MATLAB</a>, <a class="el" href="exampleMocoTrack_8py-example.html">Python</a>, <a class="el" href="exampleMocoTrack_8cpp-example.html">C++</a>    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone"><a class="el" href="classOpenSim_1_1MocoInverse.html" title="This tool solves problems in which the kinematics are prescribed and you seek the actuator (e....">MocoInverse</a>   </td><td class="markdownTableBodyNone">lower-limb   </td><td class="markdownTableBodyNone">Using the <a class="el" href="classOpenSim_1_1MocoInverse.html" title="This tool solves problems in which the kinematics are prescribed and you seek the actuator (e....">MocoInverse</a> tool for walking; <a class="el" href="classOpenSim_1_1MocoControlTrackingGoal.html">MocoControlTrackingGoal</a>; generating a PDF report   </td><td class="markdownTableBodyNone"><a class="el" href="exampleMocoInverse_8m-example.html">MATLAB</a>, <a class="el" href="exampleMocoInverse_8py-example.html">Python</a>, <a class="el" href="exampleMocoInverse_8cpp-example.html">C++</a>    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">2DWalking   </td><td class="markdownTableBodyNone">walking   </td><td class="markdownTableBodyNone"><a class="el" href="classOpenSim_1_1MocoTrack.html">MocoTrack</a>, <a class="el" href="classOpenSim_1_1MocoStudy.html" title="The top-level class for solving a custom optimal control problem.">MocoStudy</a> prediction, <a class="el" href="classOpenSim_1_1MocoControlGoal.html" title="Minimize the sum of the absolute value of the controls raised to a given exponent,...">MocoControlGoal</a>, <a class="el" href="classOpenSim_1_1MocoAverageSpeedGoal.html" title="This goal requires the average speed of the system to match a desired average speed.">MocoAverageSpeedGoal</a>, <a class="el" href="classOpenSim_1_1MocoPeriodicityGoal.html" title="This goal enforces equality between initial and final variable values in the optimal control problem.">MocoPeriodicityGoal</a>, <a class="el" href="classOpenSim_1_1MocoContactTrackingGoal.html">MocoContactTrackingGoal</a>, createPeriodicSolution   </td><td class="markdownTableBodyNone"><a class="el" href="example2DWalking_8m-example.html">MATLAB</a>, <a class="el" href="example2DWalking_8cpp-example.html">C++</a>    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">2DWalkingMetabolics   </td><td class="markdownTableBodyNone">walking   </td><td class="markdownTableBodyNone"><a class="el" href="classOpenSim_1_1MocoTrack.html">MocoTrack</a>, <a class="el" href="classOpenSim_1_1MocoControlGoal.html" title="Minimize the sum of the absolute value of the controls raised to a given exponent,...">MocoControlGoal</a>, <a class="el" href="classOpenSim_1_1MocoPeriodicityGoal.html" title="This goal enforces equality between initial and final variable values in the optimal control problem.">MocoPeriodicityGoal</a>, <a class="el" href="classOpenSim_1_1Bhargava2004SmoothedMuscleMetabolics.html" title="This class implements the metabolic energy model of Bhargava et al (2004) and provides an option to u...">Bhargava2004SmoothedMuscleMetabolics</a>   </td><td class="markdownTableBodyNone"><a class="el" href="example2DWalkingMetabolics_8cpp-example.html">C++</a>    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">MarkerTracking10DOF   </td><td class="markdownTableBodyNone">walking   </td><td class="markdownTableBodyNone"><a class="el" href="classOpenSim_1_1MocoControlGoal.html" title="Minimize the sum of the absolute value of the controls raised to a given exponent,...">MocoControlGoal</a>, <a class="el" href="classOpenSim_1_1MocoMarkerTrackingGoal.html">MocoMarkerTrackingGoal</a>   </td><td class="markdownTableBodyNone"><a class="el" href="exampleMarkerTracking10DOF_8m-example.html">MATLAB</a>    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">SquatToStand   </td><td class="markdownTableBodyNone">torque-driven single leg   </td><td class="markdownTableBodyNone"><a class="el" href="classOpenSim_1_1MocoStudy.html" title="The top-level class for solving a custom optimal control problem.">MocoStudy</a> motion prediction, <a class="el" href="classOpenSim_1_1MocoInverse.html" title="This tool solves problems in which the kinematics are prescribed and you seek the actuator (e....">MocoInverse</a>   </td><td class="markdownTableBodyNone"><a class="el" href="exampleSquatToStand_answers_8m-example.html">MATLAB</a> <a class="el" href="exampleSquatToStand_answers_8py-example.html">Python</a>    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">IMUTracking   </td><td class="markdownTableBodyNone">torque-driven single leg   </td><td class="markdownTableBodyNone"><a class="el" href="classOpenSim_1_1MocoStudy.html" title="The top-level class for solving a custom optimal control problem.">MocoStudy</a> motion prediction, <a class="el" href="classOpenSim_1_1MocoAccelerationTrackingGoal.html" title="The squared difference between a model frame origin&#39;s linear acceleration and a reference acceleratio...">MocoAccelerationTrackingGoal</a>   </td><td class="markdownTableBodyNone"><a class="el" href="exampleIMUTracking_answers_8m-example.html">MATLAB</a> <a class="el" href="exampleIMUTracking_answers_8py-example.html">Python</a>    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">EMGTracking   </td><td class="markdownTableBodyNone">lower-limb   </td><td class="markdownTableBodyNone"><a class="el" href="classOpenSim_1_1MocoInverse.html" title="This tool solves problems in which the kinematics are prescribed and you seek the actuator (e....">MocoInverse</a>, <a class="el" href="classOpenSim_1_1MocoControlTrackingGoal.html">MocoControlTrackingGoal</a>   </td><td class="markdownTableBodyNone"><a class="el" href="exampleEMGTracking_answers_8m-example.html">MATLAB</a> <a class="el" href="exampleEMGTracking_answers_8py-example.html">Python</a>    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">PredictAndTrack   </td><td class="markdownTableBodyNone">double pendulum   </td><td class="markdownTableBodyNone"><a class="el" href="classOpenSim_1_1MocoMarkerFinalGoal.html" title="The squared distance between a single model point location and reference location in the final state.">MocoMarkerFinalGoal</a>, <a class="el" href="classOpenSim_1_1MocoFinalTimeGoal.html" title="Endpoint cost for final time.">MocoFinalTimeGoal</a>, <a class="el" href="classOpenSim_1_1MocoMarkerTrackingGoal.html">MocoMarkerTrackingGoal</a>, <a class="el" href="classOpenSim_1_1MocoStateTrackingGoal.html">MocoStateTrackingGoal</a>   </td><td class="markdownTableBodyNone"><a class="el" href="examplePredictAndTrack_8py-example.html">Python</a>    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">PrototypeCustomGoal   </td><td class="markdownTableBodyNone">N/A   </td><td class="markdownTableBodyNone">Sandbox for defining a custom <a class="el" href="classOpenSim_1_1MocoGoal.html" title="A goal is a term in the cost functional to be minimized, or a set of endpoint constraints that must l...">MocoGoal</a>   </td><td class="markdownTableBodyNone"><a class="el" href="examplePrototypeCustomGoal_8m-example.html">MATLAB</a>   </td></tr>
</table>
<h1><a class="anchor" id="Advanced"></a>
Advanced</h1>
<table class="markdownTable">
<tr class="markdownTableHead">
<th class="markdownTableHeadNone">name   </th><th class="markdownTableHeadNone">model/motion   </th><th class="markdownTableHeadNone">description   </th><th class="markdownTableHeadNone">interfaces    </th></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">CustomImplicitAuxiliaryDynamics   </td><td class="markdownTableBodyNone">N/A   </td><td class="markdownTableBodyNone">Creating a component with implicit auxiliary dynamics (like muscle tendon compliance)   </td><td class="markdownTableBodyNone"><a class="el" href="exampleCustomImplicitAuxiliaryDynamics_8cpp-example.html">C++</a>    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">CustomEffortGoal   </td><td class="markdownTableBodyNone">N/A   </td><td class="markdownTableBodyNone">Creating a plugin for a custom goal   </td><td class="markdownTableBodyNone"><a class="el" href="exampleMocoCustomEffortGoal_8cpp-example.html">C++</a>   </td></tr>
</table>
</div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="mocomainpage.html">Moco</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:16 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
